package com.friday.custody.service.basicService.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.friday.custody.dao.DataDictionaryTypeOfRefinancingModeDao;
import com.friday.custody.entity.DataDictionaryTypeOfRefinancingModeDetailsEntity;
import com.friday.custody.entity.DataDictionaryTypeOfRefinancingModeEntity;
import com.friday.custody.enums.DataDictionaryTypeEnum;
import com.friday.custody.service.basicService.DataDictionaryTypeOfRefinancingModeDetailsService;
import com.friday.custody.service.basicService.DataDictionaryTypeOfRefinancingModeService;
import com.friday.custody.service.logicService.DataDictionaryBasicService;
import com.friday.custody.utils.PageUtils;
import com.friday.custody.utils.Query;
import com.friday.custody.utils.R;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
/*
* 再融资方式
* */

@Service("dataDictionaryTypeOfRefinancingModeService")
public class DataDictionaryTypeOfRefinancingModeServiceImpl extends ServiceImpl<DataDictionaryTypeOfRefinancingModeDao, DataDictionaryTypeOfRefinancingModeEntity> implements DataDictionaryTypeOfRefinancingModeService, DataDictionaryBasicService {

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<DataDictionaryTypeOfRefinancingModeEntity> page = this.page(
                new Query<DataDictionaryTypeOfRefinancingModeEntity>().getPage(params),
                new QueryWrapper<DataDictionaryTypeOfRefinancingModeEntity>()
        );

        return new PageUtils(page);
    }
    @Autowired
    //private DataDictionaryTypeOfSellerDetailsService detailsService;
    private DataDictionaryTypeOfRefinancingModeDetailsService detailsService;

    @Override
    public Map<String, String> queryWithDetail(DataDictionaryTypeEnum dicType, String trustNo) {
        return null;
    }

    @Override
    public Map<String, String> queryWithDetail(String trustNo) {
        HashMap<String, String> result = new HashMap<>();
        List<DataDictionaryTypeOfRefinancingModeEntity> allDatas = baseMapper.selectList(new QueryWrapper<>());
        if (!CollectionUtils.isEmpty(allDatas)) {
            List<DataDictionaryTypeOfRefinancingModeDetailsEntity> detailsEntities = detailsService.selectVByTrustNo(trustNo);
            if (!CollectionUtils.isEmpty(detailsEntities)) {
                Map<String, Integer> originValueKeyMap = detailsEntities.stream().collect(Collectors.toMap(DataDictionaryTypeOfRefinancingModeDetailsEntity::getOriginValue, DataDictionaryTypeOfRefinancingModeDetailsEntity::getDicId));
                Map<Integer, String> idKeyMap = allDatas.stream().collect(Collectors.toMap(DataDictionaryTypeOfRefinancingModeEntity::getId, DataDictionaryTypeOfRefinancingModeEntity::getKeyStr));
                originValueKeyMap.forEach((originValue, id) -> {
                    result.put(originValue, idKeyMap.get(id));
                });
            } else {
                log.error("DataDictionaryTypeOfSellerDetailsEntity 查询失败！");
            }
        } else {
            log.error("DataDictionaryTypeOfSellerEntity 查询失败！");
        }
        return result;
    }

    @Override
    public R queryData(String type) {
        List<DataDictionaryTypeOfRefinancingModeEntity> entities = baseMapper.selectList(new QueryWrapper<>());
        if (!org.springframework.util.CollectionUtils.isEmpty(entities)) {
            return R.ok("查询字典信息成功！")
                    .put("data", entities.stream().collect(Collectors.toMap(DataDictionaryTypeOfRefinancingModeEntity::getKeyStr
                            ,DataDictionaryTypeOfRefinancingModeEntity::getValue)));
        }
        return R.ok("字典信息为空，请联系管理员配置！");
    }
}